//---------------------------------------------------------------------------
#ifndef VCustomDataSourceOrderingH
#define VCustomDataSourceOrderingH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

enum  TFieldOrderType
 {
  FieldOrderNone       ,   //  ,     
  FieldOrderAscending  ,   //  
  FieldOrderDescending     //  
 };

class TVCustomDataSourceOrdering;

//---------------------------------------------------------------------------
class PACKAGE TVCustomDataSourceItem : public TCollectionItem
 {
  private       :
  AnsiString                   FFieldName;
  TFieldOrderType              FFieldOrder;

  void            __fastcall   SetFieldName   (AnsiString       Value);
  AnsiString      __fastcall   GetFieldName   (void);

  void            __fastcall   SetFieldOrder  (TFieldOrderType  Value);
  TFieldOrderType __fastcall   GetFieldOrder  (void);

  protected     :
  public        :

  __fastcall virtual TVCustomDataSourceItem(Classes::TCollection* Collection);

  __published   :
  __property AnsiString      FieldName  = {read=GetFieldName  , write=SetFieldName};
  __property TFieldOrderType FieldOrder = {read=GetFieldOrder , write=SetFieldOrder};
 };

//---------------------------------------------------------------------------
class PACKAGE TVCustomDataSourceItems : public TCollection
 {
  private       :
  TVCustomDataSourceOrdering  *DataSourceOrdering;

  protected     :

  DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);

  public        :
  __fastcall  TVCustomDataSourceItems(TVCustomDataSourceOrdering  *DataSourceOrdering,
                                      System::TMetaClass           *FieldClass);
 };
//---------------------------------------------------------------------------
class PACKAGE TVCustomDataSourceOrdering : public TComponent
 {
  private       :
  TVCustomDataSourceItems           *FItems;
  bool                               FActiveFlag;

  void                     __fastcall  SetItems         (TVCustomDataSourceItems  *Value);
  TVCustomDataSourceItems* __fastcall  GetItems         (void);

  void                     __fastcall  SetActive        (bool         Value);
  bool                     __fastcall  GetActive        (void);

  TFieldOrderType          __fastcall  GetNextSortOrder (AnsiString   FieldNameStr);

  bool                     __fastcall  FoundItem        (AnsiString   FieldNameStr,
                                                         int         *ItemIndexPtr);

  protected     :
  public        :
                   __fastcall           TVCustomDataSourceOrdering(TComponent* Owner);
                   __fastcall  virtual ~TVCustomDataSourceOrdering(void);

                   //    ADO  BDE
                   //    .
  void             __fastcall  virtual UpdateQuery(void);

                   //   
  void             __fastcall  ReversiveSort  (AnsiString       FieldNameStr);
  void             __fastcall  SortBy         (AnsiString       FieldNameStr,
                                               TFieldOrderType  FieldOrder);

                   //     
                   //    
  TFieldOrderType  __fastcall  GetSortOrder   (AnsiString       FieldNameStr);

  __published   :
  __property TVCustomDataSourceItems* Items  = {read=GetItems  , write=SetItems};
  __property bool                     Active = {read=GetActive , write=SetActive, default=false};
 };
//---------------------------------------------------------------------------
#endif
