//---------------------------------------------------------------------------

#ifndef VDBLookupComboBoxH
#define VDBLookupComboBoxH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <DB.hpp>
#include <dbctrls.hpp>
//---------------------------------------------------------------------------
class PACKAGE VDBLookupComboBox : public TCustomComboBox
 {
  private      :
  TLocateOptions              LocateOptions;
  TListSourceLink            *FListLink;
  AnsiString                  FKeyFieldName;
  AnsiString                  FKeyFieldValue;
  AnsiString                  FListFieldName;
  AnsiString                  FDataFieldName;
  bool                        InitInfoFlag;

  void             __fastcall SetKeyFieldName    (const AnsiString   Value);
  AnsiString       __fastcall GetKeyFieldName    (void);

  void             __fastcall SetKeyFieldValue   (const AnsiString   Value);
  AnsiString       __fastcall GetKeyFieldValue   (void);

  void             __fastcall SetListFieldName   (const AnsiString   Value);
  AnsiString       __fastcall GetListFieldName   (void);

  void             __fastcall SetDataFieldName   (const AnsiString   Value);
  AnsiString       __fastcall GetDataFieldName   (void);

  void             __fastcall SetListSource      (Db::TDataSource  *Value);
  Db::TDataSource* __fastcall GetListSource      (void);

  virtual  void    __fastcall CreateWnd          (void);

  protected    :
  DYNAMIC   void   __fastcall  Change            (void);
  virtual   void   __fastcall  DefaultHandler    (void             *Message);

  public       :
                   __fastcall  VDBLookupComboBox (TComponent       *Owner);
  virtual          __fastcall ~VDBLookupComboBox (void);
  void                         Refresh           (void);

  __published  :
  __property AnsiString       KeyField   = {read=GetKeyFieldName , write=SetKeyFieldName};
  __property AnsiString       KeyValue   = {read=GetKeyFieldValue, write=SetKeyFieldValue};
  __property AnsiString       ListField  = {read=GetListFieldName, write=SetListFieldName};
  __property AnsiString       DataField  = {read=GetDataFieldName, write=SetDataFieldName};
  __property Db::TDataSource* ListSource = {read=GetListSource   , write=SetListSource};
  __property TabOrder;
  __property OnChange;

 };
//---------------------------------------------------------------------------
#endif
